



/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP version:
 *   0-9
 */
 
 
package org.apache.qpid.framing.amqp_0_9;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.HashMap;

import org.apache.qpid.framing.*;
import org.apache.qpid.AMQException;

public class MessageConsumeBodyImpl extends AMQMethodBody_0_9 implements MessageConsumeBody
{
    private static final AMQMethodBodyInstanceFactory FACTORY_INSTANCE = new AMQMethodBodyInstanceFactory()
    {
        public AMQMethodBody newInstance(DataInputStream in, long size) throws AMQFrameDecodingException, IOException
        {
            return new MessageConsumeBodyImpl(in);
        }
		
 
    };
    
	
    public static AMQMethodBodyInstanceFactory getFactory()
    {
        return FACTORY_INSTANCE;
    }

    public static final int CLASS_ID =  120; 
    
    public static final int METHOD_ID = 20; 
    

	
    // Fields declared in specification
    private final int _ticket; // [ticket]
    private final AMQShortString _queue; // [queue]
    private final AMQShortString _destination; // [destination]
    private final byte _bitfield0; // [noLocal, noAck, exclusive]
    private final FieldTable _filter; // [filter]

    
    // Constructor

    public MessageConsumeBodyImpl(DataInputStream buffer) throws AMQFrameDecodingException, IOException
    {
        _ticket = readUnsignedShort( buffer );
        _queue = readAMQShortString( buffer );
        _destination = readAMQShortString( buffer );
        _bitfield0 = readBitfield( buffer );
        _filter = readFieldTable( buffer );
	}
	
    public MessageConsumeBodyImpl(
                                int ticket,
                                AMQShortString queue,
                                AMQShortString destination,
                                boolean noLocal,
                                boolean noAck,
                                boolean exclusive,
                                FieldTable filter
                            )
    {
        _ticket = ticket;
        _queue = queue;
        _destination = destination;
        byte bitfield0 = (byte)0;
        if( noLocal )
		{		    
            bitfield0 = (byte) (((int) bitfield0) | (1 << 0));
		}
 
        if( noAck )
		{		    
            bitfield0 = (byte) (((int) bitfield0) | (1 << 1));
		}
 
        if( exclusive )
		{		    
            bitfield0 = (byte) (((int) bitfield0) | (1 << 2));
		}
 
        _bitfield0 = bitfield0; 
        _filter = filter;
    }
    
    public int getClazz() 
    { 
        return CLASS_ID; 
    }
    
    public int getMethod() 
    { 
        return METHOD_ID; 
    }

    
    public final int getTicket()
    {
        return _ticket;
    }
    public final AMQShortString getQueue()
    {
        return _queue;
    }
    public final AMQShortString getDestination()
    {
        return _destination;
    }
    public final boolean getNoLocal()
    {
        return (((int)(_bitfield0)) & ( 1 << 0)) != 0;
    }
    public final boolean getNoAck()
    {
        return (((int)(_bitfield0)) & ( 1 << 1)) != 0;
    }
    public final boolean getExclusive()
    {
        return (((int)(_bitfield0)) & ( 1 << 2)) != 0;
    }
    public final FieldTable getFilter()
    {
        return _filter;
    }

    protected int getBodySize()
    {      
	    int size = 3;
        size += getSizeOf( _queue );
        size += getSizeOf( _destination );
        size += getSizeOf( _filter );
        return size;        
    }

    public void writeMethodPayload(DataOutputStream buffer) throws IOException
    {
        writeUnsignedShort( buffer, _ticket );
        writeAMQShortString( buffer, _queue );
        writeAMQShortString( buffer, _destination );
        writeBitfield( buffer, _bitfield0 );
        writeFieldTable( buffer, _filter );
    }

    public boolean execute(MethodDispatcher dispatcher, int channelId) throws AMQException
	{
    return ((MethodDispatcher_0_9)dispatcher).dispatchMessageConsume(this, channelId);	

	    
	}
	
	
    public String toString()
    {
        StringBuilder buf = new StringBuilder("[MessageConsumeBodyImpl: ");
        buf.append( "ticket=" );
		buf.append(  getTicket() );
		buf.append( ", " );		
        buf.append( "queue=" );
		buf.append(  getQueue() );
		buf.append( ", " );		
        buf.append( "destination=" );
		buf.append(  getDestination() );
		buf.append( ", " );		
        buf.append( "noLocal=" );
		buf.append(  getNoLocal() );
		buf.append( ", " );		
        buf.append( "noAck=" );
		buf.append(  getNoAck() );
		buf.append( ", " );		
        buf.append( "exclusive=" );
		buf.append(  getExclusive() );
		buf.append( ", " );		
        buf.append( "filter=" );
		buf.append(  getFilter() );
        buf.append("]");
        return buf.toString();
    }


}
